@import "../../../../scss/variables";
@import "../../../../scss/portal-communes";
@import '../../../../../node_modules/bulma/sass/utilities/_all.sass';

$animation-duration: 0.5s;
$tan-feedback-angle: 0.10510423526; // this is tan of the angle (6°) of the feedback section
$feedback-button-width: 12.6rem;
$feedback-button-height: 70px;
$container-polygon-starting-point: calc(100vh * 0.10510423526); // calc of the x coordinate of the polygon (refere to triangle geometry)
$button-polygon-starting-point: calc(#{$feedback-button-height} * 0.10510423526); // calc of the x coordinate of the polygon (refere to triangle geometry)
$length-due-to-diag-at-btn-position-on-home-page: calc((50vh - #{$feedback-button-height} / 2) * 0.10510423526); // the button is placed at half the heigh of the viewport minus half the height of the button, we find the length multiplying by the tangente of the angle
$length-due-to-diag-at-btn-position: calc(100vh * 0.10510423526);
$part-of-the-button-to-hide: calc(#{$feedback-button-width} - 2rem - 35px); // width of the button the svg width plus its margin right
$part-of-the-button-to-hide-negative: calc(-#{$feedback-button-width} + 2rem + 35px); // width of the button the svg width plus its margin right

::placeholder { /* Chrome, Firefox, Opera, Safari 10.1+ */
  color: $grey-dark-color;
  opacity: 1; /* Firefox */
}

form {
  background-color: $grey-background-color;
  padding: 1.4rem 1.4rem 1.4rem 1.4rem;
  border-bottom-left-radius: 8px;
  border-bottom-right-radius: 8px;
}

form p {
  color: $grey-dark-color;
  font-size: 0.75rem;
}

form p.is-strong {
  font-weight: 600;
  font-size: 0.875rem;
}

form p.is-small {
  font-size: 0.625rem;
  line-height: 1.4;
}

form textarea {
  width: 100%;
  margin: 0.5rem 0 1.4rem 0;
  font-size: 0.875rem;
  resize: none;
  overflow: auto;
  color: $brand-color;
  border-radius: 4px;
}

form input {
  margin: 0.5rem 0 1rem 0;
}

form .is-checkradio[type="checkbox"] + label {
  margin: 0;
  display: flex;
  align-items: center;
}

form .is-checkradio[type="checkbox"] + label::before {
  top: 0.5rem;
}

form .is-checkradio[type="checkbox"] + label::after {
  top: 0.8rem;
  left: 0.5rem;
}

form label span,
form label a {
  text-transform: none;
}

form .is-checkradio[type="checkbox"] + label.feedback-consent {
  margin: 0 0 1rem 0;
}

label.feedback-consent {

  p,
  span,
  a {
    font-size: 0.625rem;
    line-height: 1.4;
  }
}

.feedback-form-feeling-wrapper label {
  color: $grey-dark-color;
  text-transform: none;
  font-size: 0.75rem;
}

.feedback-form-feeling-wrapper label::after {
  content: " ";
  width: 100%;
  height: 100%;
  border: 1px solid #dbdbdb;
  border-radius: 10px;
  position: absolute;
  top: 0;
  left: 0;
}

.feedback-form-feeling-wrapper label:hover::after,
.feedback-form-feeling-wrapper label:focus::after {
  border: 1px solid $tomato-color;
}

button.feedback-button {
  clip-path: polygon($button-polygon-starting-point 0, 100% 0, 100% 100%, 0 100%);
  background-color: $tomato-color;
  position: fixed;
  display: flex;
  align-items: center;
  white-space: normal;
  padding: 0 0 0 0;
  line-height: 1.1;
  cursor: pointer;
  border: none;
  height: $feedback-button-height;
  width: $feedback-button-width;
  right: $part-of-the-button-to-hide-negative;
  top: 0;

  svg {
    width: 35px;
    height: 32px;
    min-width: 35px;
    min-height: 32px;
    margin-left: 1.2rem;

    .color-brand {
      fill: $grey-background-color;
    }

    .color-beta {
      fill: $tomato-color;
    }
  }

  span {
    visibility: hidden;
    color: $grey-background-color;
    font-size: 1.125rem;
    font-weight: bold;
    text-align: right;
    transition: text-align $animation-duration;
    margin-left: 1rem;
  }

  @media screen and (max-width: $tablet) {
    display: none;
  }
}

// .on-home-page button.feedback-button {
//   top: calc(50vh - 1.9rem);
//   right: 0;

//   span {
//     visibility: visible;
//   }
// }

.feedback-form-feeling-wrapper {
  display: flex;
  justify-content: space-between;
  margin: 0.5rem 0 1rem 0;

  @media screen and (max-width: $tablet) {
    margin: 0 -0.4rem 1rem -0.4rem;
    flex-wrap: wrap;
  }

  input {
    position: absolute;
    z-index: -1;
    opacity: 0;
  }

  .custom-radio-btn-wrapper {
    @media screen and (max-width: $tablet) {
      width: 50%;
      padding: 0.4rem;
    }

    width: 72px;
  }

  .custom-radio-btn {
    position: relative;
    display: flex;
    flex-direction: column;
    align-items: center;
    height: 66px;
    padding: 0.3rem;

    svg {
      display: block;
      height: 22px;
      margin: 0.35rem 0;
    }

    svg path {
      fill: $grey-super-light-color;
    }
  }
}

.feedback-form-feeling-wrapper input[type="radio"]:checked {
  & ~ label::after {
    border: 2px solid $tomato-color;
    z-index: -1;
    background-color: white;
  }

  & ~ label {
    z-index: 0;
    font-weight: bold;
  }

  & + svg {
    z-index: 1;

    path {
      fill: $yellow-dd-color;
    }
  }
}

.consent-text {
  margin-top: 1rem;
}

.action {
  width: 100%;
  text-align: center;
  margin: 0.4rem 0 0 0;
  // height: unset;
  // text-align: right;
  // border-top: 1px solid $grey-super-light-color;
  // background-color: white;
  // padding: 0.5rem;

  button {
    background-color: $tomato-color;
    color: white;
    font-size: 1rem;
    font-weight: bold;
    width: 208px;
    max-width: 100%;
    height: 44px;
  }
}

.feedback-component-container {
  z-index: 9;
  position: fixed;
  min-height: 100vh;

  --feedback-container-width: 100%;

  @media screen and (min-width: $tablet) {
    --feedback-container-width: 620px;
  }

  &.on-home-page {
    --translate-value: calc(-1 * var(--feedback-container-width) + #{$length-due-to-diag-at-btn-position-on-home-page} + #{$part-of-the-button-to-hide});
    --onethird-percent-button-position: 0;
  }

  &:not(.on-home-page) {
    --translate-value: calc(-1 * var(--feedback-container-width) + #{$length-due-to-diag-at-btn-position});
    --onethird-percent-button-position: -180px;
  }
}

.feedback-container {
  @media screen and (min-width: $tablet) {
    clip-path: polygon($container-polygon-starting-point 0, 100% 0, 100% 100%, 0 100%);
  }

  background-color: $tomato-color;
  position: fixed;
  width: var(--feedback-container-width);
  right: calc(-1 * var(--feedback-container-width));
  min-height: 100vh;
  max-height: 100vh;
  top: 0;
  display: flex;
  flex-direction: column;
  overflow: auto;
  padding: 1.375rem;
}

.button.close-btn {
  @media screen and (min-width: $tablet) {
    align-self: flex-start;
    margin-left: 33rem;
  }

  width: 47px;
  height: 47px;
  align-self: flex-end;
  margin-bottom: 1.375rem;
  border-radius: 50%;
  background-color: white;
  border-color: white;
  flex-shrink: 0;
  position: sticky;
  top: 0;
  box-shadow: 0 8px 32px 0 rgba(210, 76, 0, 0.36);
  z-index: 1;

  &:hover {
    box-shadow: none;
  }
}

div.form-header {
  padding: 1.35rem 0 1.25rem 0;
  text-align: center;

  span {
    font-size: 20px;
    font-weight: bold;
  }
}

.feedback-form-container {
  @media screen and (min-width: $tablet) {
    align-self: flex-start;
    margin-left: 8rem;
    width: 378px;
  }

  width: 100%;
  max-width: 378px;
  align-self: center;
  border-radius: 8px;
  box-shadow: 0 8px 32px 0 rgba(210, 76, 0, 0.36);
  background-color: white;
}

.why-a-beta-link {
  align-self: center;
  text-align: center;
  width: 100%;
  margin: 3rem 0 1.625rem 0;
  color: $brand-color;
  font-size: 1rem;
  font-weight: bold;

  @media screen and (min-width: $tablet) {
    align-self: flex-start;
    margin-left: 8rem;
    width: 378px;
  }
}

button.feedback-button.expended {
  animation: $animation-duration button-expended;
  animation-fill-mode: forwards;
  box-shadow: 0 4px 12px 0 rgba(0, 0, 0, 0.25);

  span {
    text-align: left;
  }
}

button.feedback-button.closed {
  animation: $animation-duration button-closed;
  animation-fill-mode: forwards;
}

.feedback-container.expended {
  animation: $animation-duration form-expended;
  animation-fill-mode: forwards;
  box-shadow: 0 6px 12px 0 rgba(0, 0, 0, 0.25);
}

.feedback-container.closed {
  animation: $animation-duration form-closed;
  animation-fill-mode: forwards;
}

@keyframes button-expended {
  0% {
    transform: translateX(0);
  }

  33% {
    transform: translateX(var(--onethird-percent-button-position));
  }

  100% {
    transform: translateX(var(--translate-value));
  }
}

@keyframes button-closed {
  0% {
    transform: translateX(var(--translate-value));
  }

  66% {
    transform: translateX(var(--onethird-percent-button-position));
  }

  100% {
    transform: translateX(0);
  }
}

@keyframes form-expended {
  0% {
    transform: translateX(0);
  }

  33% {
    transform: translateX(-180px);
  }

  100% {
    transform: translateX(calc(-1 * var(--feedback-container-width)));
  }
}

@keyframes form-closed {
  0% {
    transform: translateX(calc(-1 * var(--feedback-container-width)));
  }

  66% {
    transform: translateX(-180px);
  }

  100% {
    transform: translateX(0);
  }
}
